首页 > 代码库 > CDZSC_2015寒假新人(4)——搜索 I
CDZSC_2015寒假新人(4)——搜索 I
Time Limit:1000MS Memory Limit:65536KB 64bit IO Format:%I64d & %I64u
Description
The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don‘t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
31033 81791373 80171033 1033
Sample Output
670
思路:这题的意思也很容易懂,就是给出初始的4位素数后最终的4位素数,通过每次变换个十百千位其中一个(而且变后的数依然是素数)达到最终的4位素数
我认为我的代码比较巧妙的是fun函数。。。。。
#include <iostream>#include <cstdio>#include <cstring>#include <queue>#include <cmath>using namespace std;#define N 10010bool prime[N];int vis[N],step[N];int aa[]={1,10,100,1000};void table(){ int i,j; memset(prime,true,sizeof(prime)); prime[0]=false; prime[1]=false; for(i=2; i<N; i++) { if(prime[i]) { for(j=2*i; j<N; j+=i) { prime[j]=false; } } }}int fun(int num,int k)//这个函数是让num的K位变成0,例如num=1033,k=1,那么输出的就是1030{ int p[5],q=0,i; while(num>0) { p[q++]=num%10; num/=10; } p[k]=0; for(i=0; i<q; i++) { num+=p[i]*aa[i]; } return num;}int bfs(int a,int b){ int c,temp,i,j,num; memset(vis,0,sizeof(vis)); memset(step,0,sizeof(step)); vis[a]=1; queue<int>q; q.push(a); while(!q.empty()) { c=q.front(); q.pop(); /*printf("%d\n",c);*/ if(c==b) { break; } for(i=0; i<4; i++) { num=fun(c,i); for(j=0; j<=9; j++) { if(i==3&&j==0) { continue; } temp=num+(j*aa[i]); if(prime[temp]&&!vis[temp]) { vis[temp]=1; step[temp]=step[c]+1; /*printf("%d %d\n",temp,step[temp]);*/ q.push(temp); } } } } return step[b];}int main(){#ifdef CDZSC_OFFLINE freopen("in.txt","r",stdin);#endif int t,a,b,sum; table(); scanf("%d",&t); while(t--) { scanf("%d%d",&a,&b); if(a==b) { printf("0\n"); continue; } sum=bfs(a,b); printf("%d\n",sum); } return 0;}
CDZSC_2015寒假新人(4)——搜索 I
声明:以上内容来自用户投稿及互联网公开渠道收集整理发布,本网站不拥有所有权,未作人工编辑处理,也不承担相关法律责任,若内容有误或涉及侵权可进行投诉: 投诉/举报 工作人员会在5个工作日内联系你,一经查实,本站将立刻删除涉嫌侵权内容。